
from Products.CMFCore.utils import getToolByName
from cStringIO import StringIO
import sys

def Update(self):
    """\
    Calls into UpdateArticle to perform updates on CMF Article installations.
    """
    out = StringIO()
    Updater = UpdateArticle(out)
    out.write('Updating types tool configuration 1.0 to 1.1...\n')
    Updater.update_TypesToolConfiguration_10_11(target=self)

    return out.getvalue()


class UpdateArticle:
    """\
    A suite of methods for applying updates to CMF Article installations,
    used by external method(s) or other upgrade scenarios.
    """

    def __init__(self, stream):
        """\
        stream is expected to be some writable file object,
        like a StringIO, that output will be sent to.
        """
        self.stream = stream

    def update_TypesToolConfiguration_10_11(self, target):
        """\
        This updates the types tool configuration to reflect the name
        changes from 'article_edit' to 'article_edit_form' (etc), and sets
        the immediate_view to 'article_edit_form'.
        """
        typestool = getToolByName(target, 'portal_types')
        write = self.stream.write

        for ti in typestool.listTypeInfo():
            if ti.content_meta_type != 'Portal Article':
                continue
            acts = list(ti.getActions())
            for action in acts:
                ta = action['action']
                if ta in ('article_edit', 'article_element', 'article_subarticles',):
                    write(" Changed '%s' in %s to '%s_form'\n" % (ta,
                                                                  ti.id,
                                                                  ta,
                                                                   )
                          )
                    ta = '%s_form' % ta
                action['action'] = ta
            ti._actions = tuple(acts)
            initial = getattr(ti, 'immediate_view', None)
            if initial == 'topic_edit':
                s="Changed the immediate view in %s to article_edit_form" % ti.id
                write("  %s\n" % s)
                ti.immediate_view = 'article_edit_form'
